local stylesRegistry = {}
local stylesNameList = {}
local stylesNameTable = {}

local providersRegistry = {}
local providersNameList = {}
local providersNameTable = {}
local providersNameTableWithNone = {
	[""] = "None",
}

UnderHood_Bars = UnderHood:NewModule( "Bars", UnderHood.MultiFrameModulePrototype, "AceConsole-3.0", "AceEvent-3.0" )

UnderHood_Bars.configTableName = "bars"
UnderHood_Bars.configEntryPrefix = "bar"
UnderHood_Bars.configTemplate = {
	["bars"] = {
		["Threat"] = {
			["enabled"] = true,
			["strata"] = "LOW",
			["styleSettings"] = {
				["cbReversed"] = true,
				["bgColor"] = {
					0.3, -- [1]
					0.3, -- [2]
					0.3, -- [3]
					0.75, -- [4]
				},
				["bgTexture"] = "UnderHood Vertical",
				["sbVertical"] = true,
				["cbVertical"] = true,
				["showBackground"] = false,
				["sbReversed"] = true,
				["sbTexture"] = "UnderHood Vertical",
			},
			["scale"] = 1,
			["unit"] = "player",
			["y"] = 0,
			["x"] = -238,
			["name"] = "Threat",
			["style"] = "UnderHood",
			["height"] = 256,
			["level"] = 6,
			["width"] = 22,
			["zones"] = {
				{
					["provider"] = "Threat",
					["animate"] = true,
					["providerSettings"] = {
						["warningThreshold"] = 1.1,
						["colorMode"] = "amount",
						["adaptive"] = true,
					},
				}, -- [1]
				{
					["provider"] = "",
				}, -- [2]
			},
		},
		["PetMana"] = {
			["enabled"] = true,
			["strata"] = "LOW",
			["styleSettings"] = {
				["cbReversed"] = true,
				["bgColor"] = {
					0.3, -- [1]
					0.3, -- [2]
					0.3, -- [3]
					0.75, -- [4]
				},
				["bgTexture"] = "UnderHood Vertical",
				["sbReversed"] = true,
				["cbVertical"] = true,
				["showBackground"] = true,
				["sbVertical"] = true,
				["sbTexture"] = "UnderHood Vertical",
			},
			["scale"] = 1,
			["width"] = 22,
			["y"] = -28,
			["x"] = -163,
			["name"] = "PetMana",
			["unit"] = "pet",
			["height"] = 128,
			["level"] = 6,
			["style"] = "UnderHood",
			["zones"] = {
				{
					["provider"] = "Power",
					["animate"] = true,
				}, -- [1]
				{
					["provider"] = "Casting",
				}, -- [2]
			},
		},
		["PetHealth"] = {
			["enabled"] = true,
			["strata"] = "LOW",
			["styleSettings"] = {
				["cbReversed"] = true,
				["bgColor"] = {
					0.3, -- [1]
					0.3, -- [2]
					0.3, -- [3]
					0.75, -- [4]
				},
				["bgTexture"] = "UnderHood Vertical",
				["sbReversed"] = true,
				["cbVertical"] = true,
				["showBackground"] = true,
				["sbVertical"] = true,
				["sbTexture"] = "UnderHood Vertical",
			},
			["scale"] = 1,
			["unit"] = "pet",
			["y"] = -28,
			["x"] = -181,
			["name"] = "PetHealth",
			["style"] = "UnderHood",
			["height"] = 128,
			["level"] = 6,
			["zones"] = {
				{
					["provider"] = "Health",
					["animate"] = true,
					["providerSettings"] = {
						["colorByHappiness"] = false,
					},
				}, -- [1]
				{
					["provider"] = "Casting",
				}, -- [2]
			},
			["width"] = 22,
		},
		["PlayerHealth"] = {
			["enabled"] = true,
			["strata"] = "LOW",
			["styleSettings"] = {
				["cbReversed"] = true,
				["bgColor"] = {
					0.3, -- [1]
					0.3, -- [2]
					0.3, -- [3]
					0.75, -- [4]
				},
				["bgTexture"] = "UnderHood Vertical",
				["sbVertical"] = true,
				["cbVertical"] = true,
				["showBackground"] = false,
				["sbReversed"] = true,
				["sbTexture"] = "UnderHood Vertical",
			},
			["scale"] = 1,
			["unit"] = "player",
			["y"] = 0,
			["x"] = -200,
			["name"] = "PlayerHealth",
			["width"] = 22,
			["height"] = 256,
			["level"] = 6,
			["zones"] = {
				{
					["provider"] = "Health",
					["animate"] = true,
				}, -- [1]
				{
					["provider"] = "Casting",
				}, -- [2]
			},
			["style"] = "UnderHood",
		},
		["FocusMana"] = {
			["enabled"] = true,
			["strata"] = "LOW",
			["styleSettings"] = {
				["cbReversed"] = true,
				["bgColor"] = {
					0.3, -- [1]
					0.3, -- [2]
					0.3, -- [3]
					0.75, -- [4]
				},
				["bgTexture"] = "UnderHood Vertical",
				["sbVertical"] = true,
				["cbVertical"] = true,
				["showBackground"] = true,
				["sbReversed"] = true,
				["sbTexture"] = "UnderHood Vertical",
			},
			["scale"] = 1,
			["unit"] = "focus",
			["y"] = -28,
			["x"] = 162,
			["name"] = "FocusMana",
			["style"] = "UnderHood",
			["height"] = 128,
			["level"] = 6,
			["zones"] = {
				{
					["provider"] = "Power",
					["animate"] = true,
				}, -- [1]
				{
					["provider"] = "Casting",
				}, -- [2]
			},
			["width"] = 22,
		},
		["TargetMana"] = {
			["enabled"] = true,
			["strata"] = "LOW",
			["styleSettings"] = {
				["cbReversed"] = true,
				["bgColor"] = {
					0.3, -- [1]
					0.3, -- [2]
					0.3, -- [3]
					0.75, -- [4]
				},
				["bgTexture"] = "UnderHood Vertical",
				["sbVertical"] = true,
				["cbVertical"] = true,
				["showBackground"] = false,
				["sbReversed"] = true,
				["sbTexture"] = "UnderHood Vertical",
			},
			["scale"] = 1,
			["unit"] = "target",
			["y"] = 0,
			["x"] = 219,
			["name"] = "TargetMana",
			["width"] = 22,
			["height"] = 256,
			["level"] = 6,
			["zones"] = {
				{
					["provider"] = "Power",
					["animate"] = true,
				}, -- [1]
				{
					["provider"] = "",
				}, -- [2]
			},
			["style"] = "UnderHood",
		},
		["FocusHealth"] = {
			["enabled"] = true,
			["strata"] = "LOW",
			["styleSettings"] = {
				["cbReversed"] = true,
				["bgColor"] = {
					0.3, -- [1]
					0.3, -- [2]
					0.3, -- [3]
					0.75, -- [4]
				},
				["bgTexture"] = "UnderHood Vertical",
				["sbVertical"] = true,
				["cbVertical"] = true,
				["showBackground"] = true,
				["sbReversed"] = true,
				["sbTexture"] = "UnderHood Vertical",
			},
			["scale"] = 1,
			["width"] = 22,
			["y"] = -28,
			["x"] = 181,
			["name"] = "FocusHealth",
			["unit"] = "focus",
			["height"] = 128,
			["level"] = 6,
			["style"] = "UnderHood",
			["zones"] = {
				{
					["provider"] = "Health",
					["animate"] = true,
					["providerSettings"] = {
						["colorByHostility"] = false,
						["colorByClass"] = false,
					},
				}, -- [1]
				{
					["provider"] = "Casting",
				}, -- [2]
			},
		},
		["ToTHealth"] = {
			["enabled"] = true,
			["strata"] = "LOW",
			["styleSettings"] = {
				["sbReversed"] = false,
				["bgColor"] = {
					0.8117647058823529, -- [1]
					0.8117647058823529, -- [2]
					0.8117647058823529, -- [3]
					0.4900000095367432, -- [4]
				},
				["sbTexture"] = "Flat",
				["bgTexture"] = "Armory",
				["cbReversed"] = false,
				["cbVertical"] = false,
				["showBackground"] = false,
				["sbVertical"] = false,
				["texture"] = "Armory",
			},
			["scale"] = 1,
			["unit"] = "targettarget",
			["y"] = -115,
			["x"] = 0,
			["name"] = "ToTHealth",
			["style"] = "UnderHood",
			["height"] = 26,
			["level"] = 6,
			["width"] = 240,
			["zones"] = {
				{
					["provider"] = "Health",
					["animate"] = true,
					["providerSettings"] = {
						["colorByHostility"] = true,
						["colorByClass"] = false,
					},
				}, -- [1]
				{
					["provider"] = "Power",
					["animate"] = true,
				}, -- [2]
			},
		},
		["TargetHealth"] = {
			["enabled"] = true,
			["strata"] = "LOW",
			["styleSettings"] = {
				["cbReversed"] = true,
				["bgColor"] = {
					0.3, -- [1]
					0.3, -- [2]
					0.3, -- [3]
					0.75, -- [4]
				},
				["bgTexture"] = "UnderHood Vertical",
				["sbVertical"] = true,
				["cbVertical"] = true,
				["showBackground"] = false,
				["sbReversed"] = true,
				["sbTexture"] = "UnderHood Vertical",
			},
			["scale"] = 1,
			["interactive"] = false,
			["width"] = 22,
			["y"] = 0,
			["x"] = -219,
			["style"] = "UnderHood",
			["name"] = "TargetHealth",
			["height"] = 256,
			["level"] = 6,
			["zones"] = {
				{
					["provider"] = "Health",
					["animate"] = true,
					["providerSettings"] = {
						["colorByHostility"] = true,
						["colorByClass"] = false,
					},
				}, -- [1]
				{
					["provider"] = "Casting",
				}, -- [2]
			},
			["unit"] = "target",
		},
		["PlayerMana"] = {
			["enabled"] = true,
			["strata"] = "LOW",
			["styleSettings"] = {
				["cbReversed"] = true,
				["bgColor"] = {
					0.3, -- [1]
					0.3, -- [2]
					0.3, -- [3]
					0.75, -- [4]
				},
				["bgTexture"] = "UnderHood Vertical",
				["sbVertical"] = true,
				["cbVertical"] = true,
				["showBackground"] = false,
				["sbReversed"] = true,
				["sbTexture"] = "UnderHood Vertical",
			},
			["scale"] = 1,
			["unit"] = "player",
			["y"] = 0,
			["x"] = 200,
			["name"] = "PlayerMana",
			["width"] = 22,
			["height"] = 256,
			["level"] = 6,
			["zones"] = {
				{
					["provider"] = "Power",
					["animate"] = true,
				}, -- [1]
				{
					["provider"] = "Ticker",
				}, -- [2]
			},
			["style"] = "UnderHood",
		},
	},
}

function UnderHood_Bars:UpgradeFrameConfig( name, config )
	if not config.zones then
	    config.zones = {}
	    
	    local zm = {}
	    
	    zm.provider = config.provider
	    zm.providerSettings = config.providerSettings
	    zm.animate = config.animate
	    
	    config.zones[1] = zm
	    
	    config.provider = nil
	    config.providerSettings = nil
	    config.animate = nil
	    
	    if config.castingBar then
	        config.zones[2] = { provider = "Casting" }
	        config.castingBar = nil
	    end
	end
	
	if type( config.enabled ) ~= "boolean" then
	    config.enabled = true
	end
end

function UnderHood_Bars:OnInitializeFrameConfiguration( config )
	config.zones = {
	    {
	        provider = "Health",
		},
	}
	config.unit = "player"

	config.width = 22
	config.height = 256

	config.style = "UnderHood"
	stylesRegistry[config.style]:DefaultSettings( config )
	
	--[[
	for styleName, style in pairs( self:GetStyles() ) do
		config.style = styleName

		if type( style.DefaultSettings ) == "function" then
			style:DefaultSettings( config )
		end

		break
	end
	--]]
end

--[[--------
-- Providers
--]]

function UnderHood_Bars:RegisterProvider( provider )
	providersRegistry[provider.name] = provider
	
	table.insert( providersNameList, provider.name )
	providersNameTable[provider.name] = provider.title
	providersNameTableWithNone[provider.name] = provider.title
end

function UnderHood_Bars:GetProviders()
	return providersRegistry
end

function UnderHood_Bars:GetProvidersNameList()
	return providersNameList
end

function UnderHood_Bars:GetProvidersNameTable()
	return providersNameTable
end

function UnderHood_Bars:GetProvidersNameTableWithNone()
	return providersNameTableWithNone
end

function UnderHood_Bars:GetProvider( name )
	return providersRegistry[name]
end

--[[--------
-- Providers
--]]

function UnderHood_Bars:RegisterStyle( style )
	stylesRegistry[style.name] = style
	
	table.insert( stylesNameList, style.name )
	stylesNameTable[style.name] = style.title
end

function UnderHood_Bars:GetStyles()
	return stylesRegistry
end

function UnderHood_Bars:GetStylesNameList()
	return stylesNameList
end

function UnderHood_Bars:GetStylesNameTable()
	return stylesNameTable
end

function UnderHood_Bars:GetStyle( name )
	return stylesRegistry[name]
end

