local L = LibStub( "AceLocale-3.0" ):GetLocale( "UnderHood" )

UnderHood_Texts = UnderHood:NewModule( "Texts", UnderHood.MultiFrameModulePrototype, "AceConsole-3.0", "AceEvent-3.0" );

UnderHood_Texts.configTableName = "texts"
UnderHood_Texts.configEntryPrefix = "text"
UnderHood_Texts.configTemplate = {
	["texts"] = {
		["PetName"] = {
			["enabled"] = true,
			["strata"] = "LOW",
			["showMenu"] = true,
			["name"] = "PetName",
			["scale"] = 1,
			["text"] = "[Name]",
			["fontName"] = "Arial Narrow",
			["width"] = 150,
			["y"] = 44,
			["x"] = -114,
			["interactive"] = true,
			["fontOutline"] = false,
			["height"] = 18,
			["level"] = 6,
			["unit"] = "pet",
			["fontSize"] = 14,
		},
		["TargetClass"] = {
			["fontSize"] = 16,
			["scale"] = 1,
			["unit"] = "target",
			["fontOutline"] = false,
			["level"] = 6,
			["enabled"] = true,
			["text"] = "[Classification] [SmartRace:Bracket] [SmartClass:ClassColor] [DruidForm:Paren]",
			["fontName"] = "Arial Narrow",
			["width"] = 150,
			["y"] = -177,
			["x"] = 0,
			["interactive"] = true,
			["showMenu"] = true,
			["height"] = 18,
			["strata"] = "LOW",
			["name"] = "TargetClass",
			["hAlign"] = "CENTER",
		},
		["TargetGuild"] = {
			["fontSize"] = 16,
			["scale"] = 1,
			["unit"] = "target",
			["fontOutline"] = false,
			["level"] = 6,
			["enabled"] = true,
			["text"] = "[Guild:Angle]",
			["fontName"] = "Arial Narrow",
			["width"] = 150,
			["y"] = -194,
			["x"] = 0,
			["interactive"] = true,
			["showMenu"] = true,
			["height"] = 18,
			["strata"] = "LOW",
			["name"] = "TargetGuild",
			["hAlign"] = "CENTER",
		},
		["TargetName"] = {
			["fontSize"] = 16,
			["scale"] = 1,
			["unit"] = "target",
			["fontOutline"] = false,
			["level"] = 6,
			["enabled"] = true,
			["text"] = "[Level:DifficultyColor:Bracket] [Name:ClassColor] [AFK || DND]",
			["fontName"] = "Arial Narrow",
			["width"] = 200,
			["y"] = -160,
			["x"] = 0,
			["interactive"] = true,
			["showMenu"] = true,
			["height"] = 18,
			["strata"] = "LOW",
			["name"] = "TargetName",
			["hAlign"] = "CENTER",
		},
		["PlayerHealth"] = {
			["enabled"] = true,
			["strata"] = "LOW",
			["fontSize"] = 14,
			["unit"] = "player",
			["scale"] = 1,
			["text"] = "[FractionalHP:Green] [PercentHP:Percent:Green:Paren]",
			["fontName"] = "Arial Narrow",
			["width"] = 150,
			["y"] = -138,
			["x"] = -270,
			["name"] = "PlayerHealth",
			["fontOutline"] = false,
			["height"] = 18,
			["level"] = 6,
			["fontMonochrome"] = false,
			["hAlign"] = "RIGHT",
		},
		["PlayerCastName"] = {
			["enabled"] = true,
			["strata"] = "LOW",
			["unit"] = "player",
			["scale"] = 1,
			["text"] = "[~CastStopDuration ? CastName:Abbreviate] [~CastStopDuration ? CastRank:Romanize]",
			["fontName"] = "Arial Narrow",
			["width"] = 150,
			["y"] = 138,
			["x"] = -268,
			["name"] = "PlayerCastName",
			["fontOutline"] = false,
			["height"] = 18,
			["level"] = 6,
			["fontSize"] = 14,
			["hAlign"] = "RIGHT",
		},
		["TargetMana"] = {
			["enabled"] = true,
			["strata"] = "LOW",
			["scale"] = 1,
			["text"] = "[HasMP ? FractionalMP:PowerColor] [HasMP ? PercentMP:Percent:PowerColor:Paren]",
			["fontName"] = "Arial Narrow",
			["unit"] = "target",
			["y"] = -154,
			["x"] = 285,
			["name"] = "TargetMana",
			["fontOutline"] = false,
			["height"] = 18,
			["level"] = 6,
			["fontSize"] = 14,
			["width"] = 150,
		},
		["PetRemainingTime"] = {
			["enabled"] = true,
			["strata"] = "LOW",
			["unit"] = "player",
			["name"] = "PetRemainingTime",
			["scale"] = 1,
			["text"] = "[PetRemainingTime:Round]",
			["fontName"] = "Arial Narrow",
			["width"] = 150,
			["y"] = -108,
			["x"] = -75,
			["style"] = "Long",
			["category"] = "custom",
			["height"] = 16,
			["level"] = 6,
			["fontOutline"] = true,
			["fontSize"] = 20,
		},
		["ToTName"] = {
			["enabled"] = true,
			["strata"] = "MEDIUM",
			["unit"] = "targettarget",
			["scale"] = 1,
			["text"] = "[Name ? Name] [AFK || DND]",
			["fontName"] = "Arial Narrow",
			["width"] = 120,
			["y"] = -113,
			["x"] = -52,
			["name"] = "ToTName",
			["fontOutline"] = false,
			["height"] = 18,
			["level"] = 6,
			["fontSize"] = 12,
			["hAlign"] = "LEFT",
		},
		["FocusPolyTimer"] = {
			["strata"] = "LOW",
			["scale"] = 1,
			["unit"] = "focus",
			["category"] = "custom",
			["level"] = 6,
			["enabled"] = true,
			["text"] = "[AuraDuration(\"Polymorph\"):Floor]",
			["fontName"] = "Arial Narrow",
			["width"] = 150,
			["y"] = -108,
			["x"] = 75,
			["name"] = "FocusPolyTimer",
			["style"] = "Long",
			["height"] = 16,
			["fontSize"] = 20,
			["fontOutline"] = true,
			["hAlign"] = "RIGHT",
		},
		["ToTHealth"] = {
			["enabled"] = true,
			["strata"] = "MEDIUM",
			["fontSize"] = 12,
			["unit"] = "targettarget",
			["scale"] = 1,
			["text"] = "[FractionalHP:Short] ([PercentHP:Percent])",
			["fontName"] = "ABF",
			["width"] = 130,
			["y"] = -115,
			["x"] = 48,
			["name"] = "ToTHealth",
			["fontOutline"] = false,
			["height"] = 18,
			["level"] = 6,
			["fontMonochrome"] = false,
			["hAlign"] = "RIGHT",
		},
		["PlayerCastTime"] = {
			["enabled"] = true,
			["strata"] = "LOW",
			["scale"] = 1,
			["text"] = "[~CastStopDuration ? CastEndDuration:Round(2)]",
			["fontName"] = "ABF",
			["unit"] = "player",
			["y"] = 138,
			["x"] = -114,
			["name"] = "PlayerCastTime",
			["fontOutline"] = false,
			["height"] = 18,
			["level"] = 6,
			["width"] = 150,
			["fontSize"] = 14,
		},
		["FocusName"] = {
			["enabled"] = true,
			["strata"] = "LOW",
			["fontSize"] = 14,
			["scale"] = 1,
			["text"] = "[Name:Abbreviate:ClassColor] [Level:DifficultyColor:Bracket]",
			["fontName"] = "Arial Narrow",
			["unit"] = "focus",
			["y"] = 45,
			["x"] = 112,
			["name"] = "FocusName",
			["fontOutline"] = false,
			["height"] = 18,
			["level"] = 6,
			["width"] = 150,
			["hAlign"] = "RIGHT",
		},
		["TargetHealth"] = {
			["enabled"] = true,
			["strata"] = "LOW",
			["fontSize"] = 14,
			["scale"] = 1,
			["text"] = "[FractionalHP:HostileColor] [PercentHP:Percent:HostileColor:Paren]",
			["fontName"] = "Arial Narrow",
			["unit"] = "target",
			["y"] = -154,
			["x"] = -295,
			["name"] = "TargetHealth",
			["fontOutline"] = false,
			["height"] = 18,
			["level"] = 6,
			["width"] = 170,
			["hAlign"] = "RIGHT",
		},
		["Threat"] = {
			["enabled"] = true,
			["strata"] = "LOW",
			["width"] = 80,
			["scale"] = 1,
			["text"] = "[PercentThreat:Round:Hide(0):Percent:UnitThreatStatusColor]",
			["fontName"] = "ABF",
			["unit"] = "player",
			["y"] = 118,
			["x"] = -288,
			["name"] = "Threat",
			["fontOutline"] = false,
			["height"] = 18,
			["level"] = 6,
			["fontSize"] = 14,
			["hAlign"] = "RIGHT",
		},
		["PlayerMana"] = {
			["enabled"] = true,
			["strata"] = "LOW",
			["fontSize"] = 14,
			["scale"] = 1,
			["text"] = "[HasMP ? FractionalMP:PowerColor] [HasMP ? PercentMP:Percent:PowerColor:Paren]",
			["fontName"] = "Arial Narrow",
			["unit"] = "player",
			["y"] = -138,
			["x"] = 270,
			["name"] = "PlayerMana",
			["fontOutline"] = false,
			["height"] = 18,
			["level"] = 6,
			["fontMonochrome"] = false,
			["width"] = 150,
		},
	},
}

function UnderHood_Texts:UpgradeFrameConfig( name, config )
	if type( config.enabled ) ~= "boolean" then
	    config.enabled = true
	end
end

function UnderHood_Texts:OnInitializeFrameConfiguration( config )
	config.unit = "player"
	config.category = "name"
	config.style = L["Long"]
	config.text = "[Level:DifficultyColor:Bracket] [Name:ClassColor] [AFK | DND]"

	config.width = 150
	config.height = 16

	config.fontName = "ABF"
	config.fontSize = 14
	config.fontOutline = true
end
